import { Check, CircleAlert, Info, X } from 'lucide-react';
import { useDispatch, useSelector } from 'react-redux';
import { resetNotificationBar } from '../store/slices/notificationBarSlice';
import { useEffect } from 'react';

export default function NotificationBar() {
    const { message, type, show } = useSelector((state) => state.notificationBar);
    const dispatch = useDispatch();

    const setTimeOut = () => {
        setTimeout(() => {
            dispatch(resetNotificationBar());
        }, 3000);
    };

    const handleClose = () => {
        dispatch(resetNotificationBar());
    };

    useEffect(() => {
        console.log(message);
        setTimeOut();
    }, [message]);

    return (
        show && (
            <div
                className={`snackbar alert alert-${type} d-flex align-items-center justify-content-between position-fixed top-5 start-50 translate-middle w-50 gap-2`}
                role='alert'
                style={{ zIndex: 999999, top: '15%' }}
            >
                {type === 'success' && <Check />}
                {type === 'warning' && <CircleAlert />}
                {type === 'error' && <X />}
                {type === 'info' && <Info />}
                <div className='flex-fill'>{message}</div>
                <button type='button' className='btn-close flex-end' onClick={handleClose} aria-label='Close'></button>
            </div>
        )
    );
}
